<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>

<%@ page import="server.SearchServlet"%>

<%@ taglib tagdir="/WEB-INF/tags" prefix="tag"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"%>

<c:set var="queryStr"
	value="${searchcontext[SearchServlet.QUERY_INPUT]}" />
<c:set var="currentPageInt"
	value="${searchcontext[SearchServlet.CURRENT_PAGE]}" />
<c:set var="perPageInt"
	value="${searchcontext[SearchServlet.RESULTS_PER_PAGE]}" />
<c:set var="directedStr"
	value="${searchcontext[SearchServlet.DIRECTED]}" />
<c:set var="categoryArr"
	value="${searchcontext[SearchServlet.CATEGORY]}" />
<c:set var="dateStr" value="${searchcontext[SearchServlet.DATE]}" />

<html>
<head>
<title>Lucene Facet Example</title>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
</head>
<body>
	<form name="search" action="/" accept-charset="UTF-8">
		<p align="center">
			<input name="${SearchServlet.QUERY_INPUT}"
				value="<c:out value="${queryStr}"/>"
				style="text-align: center; width: 100%; font-size: 1.5em" />
		</p>
		<p style="display: flex; justify-content: center">
			<select title="Дерево: Год -> Месяц" name="${SearchServlet.DATE}">
				<option value="">-</option>
				<c:forEach items="${searchmodel.dates}" var="y">
					<option value="<c:out value="${y.key}"/>"
						${y.key == dateStr ? 'selected' : null}>
						<c:out value="${y.key} | ${y.value.key}" />
					</option>
					<c:forEach items="${y.value.value}" var="m">
						<c:set var="yyyymm"><c:out value="${y.key}-${m.key}" /></c:set>
						<option value="<c:out value="${yyyymm}"/>"
							${yyyymm == dateStr ? 'selected' : null}>
							<c:out value="-> ${m.key} | ${m.value}" />
						</option>
					</c:forEach>
				</c:forEach>
			</select> &nbsp; <select title="Режиссёр" name="${SearchServlet.DIRECTED}">
				<option value="">-</option>
				<c:forEach items="${searchmodel.directors}" var="entry">
					<option value="<c:out value="${entry.key}"/>"
						${entry.key == directedStr ? 'selected' : null}>
						<c:out value="${entry.value} | ${entry.key}" />
					</option>
				</c:forEach>
			</select> &nbsp; 
			<select title="Мульти: Жанр" multiple size="1"
				name="${SearchServlet.CATEGORY}">
				<option value="">-</option>
				<c:forEach items="${searchmodel.categories}" var="entry">
					<c:set var="isSelected" value="false" />
					<c:forEach var="cat" items="${categoryArr}">
						<c:if test="${cat == entry.key}">
							<c:set var="isSelected" value="true" />
						</c:if>
					</c:forEach>
					<option value="<c:out value="${entry.key}"/>"
						${isSelected ? 'selected' : null}>
						<c:out value="${entry.value} | ${entry.key}" />
					</option>
				</c:forEach>
			</select> &nbsp; <select title="Показывать"
				name="${SearchServlet.RESULTS_PER_PAGE}">
				<c:forTokens items="3,5,10,20,50" delims="," var="per">
					<option ${per == perPageInt ? 'selected' : null}>
						<c:out value="${per}" />
					</option>
				</c:forTokens>
			</select> &nbsp; <input type="submit" value="Поиск!" />
		</p>
	</form>

	<c:if test="${searchmodel != null}">
		<c:choose>
			<c:when test="${searchmodel.items != null}">
				<div style="float: right;">
					Page <b> ${currentPageInt} </b> from <b>${Math.ceil((1.0 * searchmodel.totalHits) / perPageInt).intValue()}</b>
				</div>
				<c:if test="${currentPageInt > 1}">
					<tag:nav current="${currentPageInt - 1}" value="<" style=" float:left;" />
				</c:if>
				<c:if test="${searchmodel.totalHits > currentPageInt * perPageInt}">
					<tag:nav current="${currentPageInt + 1}" value=">" />
				</c:if>
				<div style="clear: both;">
					<c:forEach items="${searchmodel.items}" var="item">
						<hr />
						<p>
							<b>Совпадение: </b>${item.score} <b>Кинопоиск: </b> <a
								href="http://www.kinopoisk.ru/film/${item.id}/">${item.rate}</a> 
							<b>Режиссёр: </b>
							<c:out value="${item.director}" />
						</p>
						<p>
							<b>Жанр: </b>
							<c:out value="${fn:join(item.categories, ', ')}" />
						</p>
						<p>
							<b>Название: </b>
							<tag:hi value="${item.highlightedTitle}" />
						</p>
						<p>
							<b>Описание: </b>
							<tag:hi value="${item.highlightedContent}" />
						</p>
					</c:forEach>
				</div>
			</c:when>
			<c:otherwise>
				<p align="center">Ничего не найдено :(</p>
			</c:otherwise>
		</c:choose>
	</c:if>
	<p align="center">
		<a href="http://mazko.github.io/">http://mazko.github.io/</a>
	</p>
</body>
</html>